connection master;
show create table t1;
show create table t2;

lock table t1 write, t2 write;
insert into t1 values ('original',1);

--echo #
--echo # a second session will try inserting into the *locked* table
--echo #
connection master1;
if ($immediate)
{
insert into t1 values('while locked',2);
}
if (!$immediate)
{
send insert into t1 values('while locked',2);
}
--echo # 
--echo # the main session does some operation based on the assumption that the tables
--echo # are locked
--echo # 

connection master;
delimiter //;
send insert into t2 select * from t1; unlock tables; //
delimiter ;//

--sleep 1
--echo #
--echo # the second session changes data before
--echo # the main session can finish its work
--echo #
connection master1;
if (!$immediate)
{
--reap
}

--echo #
--echo # the main session collects the results and unlocks the tables
--echo #
connection master;
--reap
--sleep 1

--echo #
--echo # let's see the results on the slave
--echo # the count should be 1
--echo #
save_master_pos;
sync_with_master;
connection slave;
select count(*) from t2;


